Improve this

jQuery

Before reading this section, we suggest you reading Getting Started and Fundamentals to grasp the basics of Onsen UI. Don’t worry, it won’t take more than 5 minutes.

Setup

Using jQuery with Onsen UI is pretty simple.

  1. Download Onsen UI.
  2. Get jQuery.
  3. Load onsenui.js and 2 CSS files.
  4. Load jQuery.

Onsen UI components can be used as other native DOM element.

Example Installation

The following code illustrates how to use jQuery with Onsen UI, both loaded from the CDN.

<!DOCTYPE html>
<html>
<head>
  <link rel="stylesheet" href="https://unpkg.com/onsenui/css/onsenui.css">
  <link rel="stylesheet" href="https://unpkg.com/onsenui/css/onsen-css-components.min.css">
  <script src="https://unpkg.com/onsenui/js/onsenui.min.js"></script>
  <script src="https://unpkg.com/jquery/dist/jquery.min.js"></script>
</head>
<body>
  <script>
    $(function(){
      // Initialization code
      $('ons-button').on('click', function(e) {
        ons.notification.alert('Button is tapped!');
      })
    });
  </script>
  <ons-button>Click me!</ons-button>
</body>
</html>

Improve this

React

Before reading this section, we suggest you reading Getting Started and Fundamentals to grasp the basics of Onsen UI. Don’t worry, it won’t take more than 5 minutes.

React bindings for Onsen UI provide React components that wrap the core Web Components and expose a React-like API to interact with them.

Download React bindings

React bindings are distributed in react-onsenui package. You can download it via NPM:

$ npm install onsenui react-onsenui --save

It is also available via CDN. The latest core release also contains React bindings.

Setup React bindings

You can load Onsen UI with normal tags as follows:

<script src="react.js"></script>
<script src="react-dom.js"></script>
<script src="onsenui.js"></script>
<script src="react-onsenui.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/babel-core/6.1.19/browser.min.js"></script>

Or you can use React and Onsen UI from npm with CommonJS module system like Browserify or Webpack. In this case, use the onsenui and react-onsenui packages, in addition to react and react-dom npm packages. In the example below ons contains Onsen UI core instance, and Ons contains React components.

var React = require('react');
var ReactDOM = require('react-dom');
var ons = require('onsenui');
var Ons = require('react-onsenui');

Alternatively, you can also use ES6 imports to specify the modules you want to use in react-onsenui package.

import { Page, Toolbar, Button } from 'react-onsenui'; // Only import the necessary components
// import * as Ons from 'react-onsenui'; // Import everything and use it as 'Ons.Page', 'Ons.Button'

The CSS can be included normally with <link> tags in index.html or can be imported by Webpack:

// Webpack CSS import
import 'onsenui/css/onsenui.css';
import 'onsenui/css/onsen-css-components.css';

Hello World with React

To get started, let’s create a simple Hello World application. The following sample code is a React version of Onsen UI HelloWorld.

<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8" />
  <link rel="stylesheet" href="css/onsenui.css">
  <link rel="stylesheet" href="css/onsen-css-components.css">
  <script src="react.js"></script>
  <script src="react-dom.js"></script>
  <script src="onsenui.js"></script>
  <script src="react-onsenui.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/babel-core/6.1.19/browser.min.js"></script>
</head>

<body>
  <div id="app"></div>

  <script type="text/babel">
    var App = React.createClass({
      handleClick: function() {
        ons.notification.alert('Hello world!');
      },

      render: function() {
        return (
          <Ons.Page>
            <Ons.Button onClick={this.handleClick}>Tap me!</Ons.Button>
          </Ons.Page>
        );
      }
    });
    ReactDOM.render(<App />, document.getElementById('app'));
  </script>
</body>
</html>

In <body> tag, there is only a <div> tag having app id. This is where React will render the content into, and you can see it in the very bottom of JS code.

Also notice <script></script> tag has text/babel type. This means this script is not a pure JavaScript that browser supports (most commonly ECMAScript5), but is a ECMAScript6 (ES2015) with JSX format. Babel will transpile this code into ES5 in the browser. To get better performance, we can use Node.js to transpile the code.

Inside the script, React.createClass() function defines a React Component called “App”. It has one method called render, and this is the function that is called when the app is rendered. The returning object is described in JSX, which is a XML like language that extends JavaScript. In this case, it is returning <Ons.Page> component that has an <Ons.Button> component. The onClick prop is used to call the handleClick method when the user taps the button.

return (
  <Ons.Page>
    <Ons.Button onClick={this.handleClick}>Tap me!</Ons.Button>
  </Ons.Page>
);

As you can see in this example, all <Ons.*> components are React Components, and they are loaded by react-onsenui.js. For a full list of React Components, see the reference page.

Putting together, when index.html is loaded into the browser, it will compile JSX code, inject into the body, and render the content.

For more information about React itself or JSX format, we recommend reading the official React docs.

Improve this

Angular 2+

Before reading this section, we suggest you reading Getting Started and Fundamentals to grasp the basics of Onsen UI. Don’t worry, it won’t take more than 5 minutes.

In this chapter, we will show you how to use ngx-onsenui, Onsen UI’s binding library for Angular.

Setup

Prerequisites

This document assumes you are somewhat familiar with Angular framework, and have an existing Angular application. If not, we suggest you to go through the official Angular guide and setup an initial project.

Install onsenui and ngx-onsenui

Use npm to install Onsen UI Core (onsenui) and the binding library for Angular (ngx-onsenui).

npm install onsenui ngx-onsenui --save
Import OnsenModule

Then, import OnsenModule into the root module (typically called AppModule) of your Angular app.

import { OnsenModule } from 'ngx-onsenui';
imports: [
   BrowserModule,
   OnsenModule,
],

This step will load all components and features of ngx-onsenui and Onsen UI Core (onsenui) into your app.

Load CUSTOM_ELEMENTS_SCHEMA

Add schemas property into the root module and put CUSTOM_ELEMENTS_SCHEMA into it. This is important since Onsen UI components are Web Components (Custom Elements).

import { CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
  schemas: [
      CUSTOM_ELEMENTS_SCHEMA,
  ],

This step suppresses warnings caused by ons-* tags in templates.

Load CSS files

Finally, load onsenui.css and onsen-css-components.css in node_modules/onsenui/css/. Make sure to do in this order!

Using Angular CLI

Append the following two lines in angular.json (.angular-cli.json for Angular 2-5). Check out the official Angular CLI guide for more details.

"styles": [
  "node_modules/onsenui/css/onsenui.css",
  "node_modules/onsenui/css/onsen-css-components.css",
  "src/styles.css"
],

Configure Manually

Modify the following two lines appropriately and append them into the global stylesheet file in your project.

@import 'node_modules/onsenui/css/onsenui.css';
@import 'node_modules/onsenui/css/onsen-css-components.css';
Ready to go!

ngx-onsenui has been set up. Have fun with Onsen UI components for Angular!

ngx-onsenui Essentials

Using components

ngx-onsenui provides various components: (see all components in list). Each components start with ons-* tag.

For example, let’s put a button.

template: `
  <ons-button>Click Me</ons-button>
`

If you want to set an action triggered when the button is clicked, you can use Angular event binding.

template: `
  <ons-button (click)="doSomething()">Click Me</ons-button>
`

If you want to know what events you can use in each component, please refer to each reference page of them.

Two-way binding

Some components (i.e. ons-input) support two-way binding. They allow [(value)]="val" syntax to synchronize the value of val with the value of ons-input.

template: `
  <ons-input type="text" [(value)]="val"></ons-input>: {{val}}
`

Some components require (input)="val = $event.target.value" in addition to [(value)]="val" syntax. For example, ons-range component won’t update the value when it’s dragged.

template: `
  <ons-range [(value)]="val" (input)="val = $event.target.value"></ons-range>
`
Using ons-page

ons-page is a special component which covers the whole screen and becomes the container for the toolbar.

ons-page must be created by writing the following code:

<ons-page>
  <div class="background"></div><!-- Background of the page -->
  <div class="content">
    <!-- Content of the page -->
  </div>
</ons-page>

background corresponds to the background of the page, and content corresponds to the content of the page. Keep in mind that page contents cannot be placed right under the ons-page.

Similarily, ons-toolbar can be used to show a toolbar at the top of the page. In this case, ons-toolbar has to be the direct first child of ons-page.

<ons-page>
  <ons-toolbar>
    <div class="center"><!-- Toolbar title --></div>
  </ons-toolbar>
  <div class="background"></div>
  <div class="content">
    <!-- Content of the page -->
  </div>
</ons-page>
Managing pages with navigator, splitter and tabbar

ngx-onsenui provides three special components to mangae pages: ons-navigator, ons-splitter and ons-tabbar. They allow native-like page transitions.

Page managers will automatically create, destroy and animate multiple ons-pages. Let’s see in code with ons-navigator.

Defining a page

To use page managers, each pages need to be defined as Angular components. It can be achieved by setting ons-page[some-id] for the selector and describing the page content inside template.

@Component({
  selector: 'ons-page[first]',
  template: `
    <ons-toolbar>
      <div class="center">First</div>
    </ons-toolbar>
    <div class="background"></div>
    <div class="content">
      First page
    </div>
  `
})
export class FirstPageComponent {
}

A unique page ID should be specified (first in the example above). Otherwise, the original definition of the ons-page directive will be broken and it leads to unexpected behavior.

Then, add the page component into entryComponents property of the root module (Typical name: AppModule).

  entryComponents: [
    FirstPageComponent
  ],

This step is required so that ons-navigator can dynamically create and destroy FirstPageComponent. If not, No component factory found for FirstPageComponent error will be shown.

Set default page of ons-navigator

Now ons-navigator component is available. Use [page] attribute to specify the default page.

@Component({
  selector: 'app-root',
  template: `
    <ons-navigator [page]="initialPage"></ons-navigator>
  `
})
export class AppComponent {
  initialPage = FirstPageComponent;
}

With the code above, it will show the page content in FirstPageComponent component.

And in this example, we defined initialPage and assigned the value to it. It is because Angular does not allow using a variable (FirstPageComponent) outside the class.

Pushing a page

ons-navigator manages pages in the form of a stack. Adding a page to the front screen is called “push”, and removing a foremost page is called “pop”.

Let’s try pushing another page content when a button is pressed.

First, define another page with the name SecondPageComponent and add it into entryComponents property.

@Component({
  selector: 'ons-page[second]',
  template: `
    <ons-toolbar>
      <div class="center">Second</div>
    </ons-toolbar>
    <div class="background"></div>
    <div class="content">
      Second page
    </div>
  `
})
export class SecondPageComponent {
}
  entryComponents: [
    FirstPageComponent,
    SecondPageComponent
  ],

Then, add a button and a short code to push FirstPageComponent page.

import { OnsNavigator } from 'ngx-onsenui';

@Component({
  selector: 'ons-page[first]',
  template: `
    <ons-toolbar>
      <div class="center">First</div>
    </ons-toolbar>
    <div class="background"></div>
    <div class="content">
      First page<br>
      <ons-button (click)="push()">Push</ons-button>
    </div>
  `
})
export class FirstPageComponent {
  // Get a way to access `ons-navigator` by Dependency Injection (DI)
  constructor(private navigator: OnsNavigator) {
  }

  push() {
    // Push SecontPageComponent to `ons-navigator
    this.navigator.element.pushPage(SecondPageComponent);
  }
}

Voila. The page defined by SecondPageComponent will slide from the right when the button is pressed.

To summarize, pushing pages to ons-navivator requires the following two steps:

  1. Give a way (= the directive instance) to access ons-navigator by Dependency Injection (DI)
  2. Push SecondPageComponent to ons-navigator with pushPage

Please note that the method to call is this.navigator.element.pushPage, and not this.navigator.pushPage.

Similarly, if you want to pop pages, execute this.navigator.element.popPage when SecondPageComponent is displayed.

Passing parameters to the new page

You can pass parameters to a destination page when a pushing / popping page.

To pass a parameter, use data option when calling pushPage:

this.navigator.element.pushPage(SecondPageComponent, {data: {foo: 1234}});

Passed parameters can be received in the destination page using Dependency Injection (DI).

import { Params } from 'ngx-onsenui';
constructor(private params: Params) {
  console.log(JSON.stringify(params.data)); // => {"foo": 1234}
}

pushPage has several options as well as data option such as animationoption (for more details, please refer to ons-navigator). You can retrieve all the options with Params as well as data option.

More examples

Each components are equipped with working examples. Please refer to examples directory in the repository.

For instance, carousel.ts contains information about what code you would write when using ons-carousel compoennt.

Architecture

This section may contain advanced information.

Wrapping Web Components with Angular directives

ngx-onsenui provides a feature to set default page with [page], two-way binding and other features, which cannot be realized by features of Web Components itself, by wrapping elements defined in Web Components layer with Angular directives.

For example, ons-navigator element is wrapped with OnsNavigator directive and ons-switch element is wrapped with OnsSwitch directive.

However not all the components have corresponding directives. For example, ons-button element is not wrapped with any directives since there is no need to wrap the element.

About the list of all the directives provided by ngx-onsenui, please refer to the definition of OnsenModule (GitHub).

How to directly call methods in Web Components layer

In Web Components, methods are directly defined in DOM elements. To call the methods, you can access elements in some way such as querySelector().

In Angular, you can also access DOM elements with template reference variables (Example: #var). For more details, please refer to the official Angular guide.

About angular2-onsenui

angular2-onsenui which is previously provided has been obsoleted since Angular 4 was announced. If you are still using angular2-onsenui, we recommend that you update it to ngx-onsenui.

Before reading this section, we suggest you reading Getting Started and Fundamentals to grasp the basics of Onsen UI. Don’t worry, it won’t take more than 5 minutes.
Vue bindings for Onsen UI (VueOnsen) provide Vue 2 components and directives that wrap the core Web Components and expose a Vue-like API to interact with them.
In this guide, we’ll walk you through how to set up Onsen UI + Vue and cover basics to get started.
If you install version 3 of the Vue CLI, you can take advantage of features that make setting up an Onsen UI + Vue project really simple.
First, make sure you have at least version 3 of the CLI (the @vue/cli package, not vue-cli).
npm install -g @vue/cli
Now you can set up your app by using the create command. This will guide you through various options. Please note: For starting your Onsen UI phone app do not add the Progressive Web App (PWA) support option which is for deploying to a website and not to a device.
vue create my-onsen-app
Once you have a Vue project set up, you just need to install the core Onsen UI package (onsenui), and the Vue bindings (vue-onsenui). Inside the project root, run:
npm install onsenui vue-onsenui
Inside your project’s main file (usually main.js), Onsen UI’s files need to be imported.
// Webpack CSS import
import 'onsenui/css/onsenui.css';
import 'onsenui/css/onsen-css-components.css';
// JS import
import Vue from 'vue';
import VueOnsen from 'vue-onsenui'; // This imports 'onsenui', so no need to import it separately
Vue.use(VueOnsen); // VueOnsen set here as plugin to VUE. Done automatically if a call to window.Vue exists in the startup code.
To get started, let’s create a simple Hello World application. Projects set up using the Vue CLI are single file components. This means the HTML, CSS and JS are all contained in one .vue file. The default project created by the CLI will have at least an App.vue file. Edit it to look like this.
<template id="main-page">
<v-ons-page>
<v-ons-toolbar>
<div class="center">Title</div>
</v-ons-toolbar>
<p style="text-align: center">
<v-ons-button @click="$ons.notification.alert('Hello World!')">
Click me!
</v-ons-button>
</p>
</v-ons-page>
</template>
<style>
/* CSS goes here */
</style>
<script>
// Javascript goes here
</script>
Projects created by the Vue CLI come with various scripts, including one to serve the project so you can preview it in the browser.
npm run serve
Open the given URL in your browser. If you click the button, you will see an alert dialog. That’s it!
To continue from here, take a look at the Onsen UI Vue Components list. You should also take a look at our Kitchensink Example which shows all the Onsen UI components being used with Vue. For more information about Vue itself, we recommend reading the official Vue docs. If you want to know more about how the bindings word, keep reading below.
Onsen UI’s Vue components are simple wrappers around inner Custom Elements in most of the cases. This means that a Vue Component takes some props and translates them into DOM properties, DOM attributes or method calls for the Onsen UI core. It also listens for native events and fires the corresponding Vue events. If you inspect the DOM you will likely see a bunch of ons-* components without v-* prefix (these are real HTML elements). You can have a look at the implementation here.
Since v-ons-* components compile into ons-* DOM elements, you can use this knowledge to style your component with tag names as well. For example, if you want to style a button, you should target ons-button, not v-ons-button.
v-ons-page component compiles into ons-page custom element. This element, at the same time, processes its content and filters scrollable and fixed elements. Scrollable content is moved into a special div.page__content wrapper. This behavior might create issues under some specific situations, like using v-for with asynchronous data. To avoid any possible issue, manually providing a div.content element is recommended:
<v-ons-page>
<v-ons-toolbar></v-ons-toolbar>
<div class="content">
<!-- Scrollable content here -->
<v-ons-input></v-ons-input>
<div v-for="item in asyncAjaxItems"></div>
</div>
<!-- Fixed content here -->
<v-ons-fab></v-ons-fab>
</v-ons-page>
See also Components Compilation section for more details about this.
The original ons object is not available in the global scope in Vue applications. Instead, it is provided in every Vue instance as this.$ons through Vue’s protoytpe:
<v-ons-button @click="$ons.notification.alert('Hi there!')">
Click me
</v-ons-button>
DOM events fired by Onsen UI elements are translated into Vue events in the corresponding components. For example, v-ons-navigator can handle a postpush event with @postpush="...".
From `vue@2.4.0andvue-onsenui@2.1.0onwards, native DOM events are passed down to the children. This means thatwill work __without__nativemodifier. Prior to these versions,@change.native=”…”` syntax is required. Note that these events are still DOM events and, as such, Vue DevTools won’t show any Vue event for these.
The exception to this is click event, which is turned into a Vue event in some components. The reason is that click event is used to override default behaviors:
<v-ons-back-button @click.prevent="pageStack.splice(1)"></v-ons-back-button>
The previous example overrides the v-ons-back-button default behavior, popping 1 single page, and resets the stack to the first page instead. The prevent modifier is just calling $event.preventDefault().
Additionally, components that are capable of handling Cordova’s backbutton event (Android’s back button), can listen for this event with @deviceBackButton handler.
<v-ons-dialog @deviceBackButton="$event.callParentHandler()"></v-ons-dialog>
More information about this event in the original Cordova-specific Features section.
Input components in Onsen UI (such as v-ons-input or v-ons-checkbox) support Vue’s v-model directive:
<v-ons-input v-model="something"></v-ons-input>
The only exceptions are v-model modifiers, which are not supported by custom components as of `vue@2.3, unfortunately. However, there is a workaround for the most important one, thelazy` modifier:
<v-ons-input v-model="something" model-event="change"></v-ons-input>
This will update the model on change events instead of input (default). The rest of the modifiers can be easily implemented in other ways.
It is also possible to bind arrays to v-ons-checkbox or v-ons-switch just like normal <input type="checkbox">, and make radio groups with v-model for v-ons-radio.
Apart from the full vue-onsenui bundle, an ESM version is provided under vue-onsenui/esm since `vue-onsenui@2.4.0`. The main benefit of using this distribution is that components you don’t use will be left out of the bundle without relying on tree shaking algorithms. This helps reduce your app’s size. See our core guide to ES Modules for more information.
import Vue from 'vue';
import VueOnsen from 'vue-onsenui/esm';
import VOnsPage from 'vue-onsenui/esm/components/VOnsPage';
import VOnsToolbar from 'vue-onsenui/esm/components/VOnsToolbar';
Vue.use(VueOnsen);
Vue.component(VOnsPage.name, VOnsPage);
Vue.component(VOnsToolbar.name, VOnsToolbar);
The previous code imported VueOnsen (which is just an alias for $ons object) and registers it in Vue. This step does not include any components at all, unlike import VueOnsen from 'vue-onsenui' would do. Therefore, we can import the necessary components manually and register them as global Vue components (optional). Components have a name property that can be used for registering them in Vue (v-ons-page, v-ons-button, etc).
Since importing and registering many components can be very verbose, we recommend creating an extra file with the desired list of components using the following export syntax:
// onsenui-components.js
export { default } from 'vue-onsenui/esm/components/VOnsToolbar';
export { default } from 'vue-onsenui/esm/components/VOnsNavigator';
export { default } from 'vue-onsenui/esm/components/VOnsPage';
export { default } from 'vue-onsenui/esm/components/VOnsCarousel';
Then, simply import and register everything in your main file:
// main.js
import Vue from 'vue';
import VueOnsen from 'vue-onsenui/esm';
import * as OnsenComponents from './onsenui-components.js';
Vue.use(VueOnsen);
Object.values(OnsenComponents).forEach(c => Vue.component(c.name, c));
In case you don’t want to use the default c.name provided, you can assign a new one with export { default as CustomName } from 'vue-onsenui/esm/component/...;' and then using the object key instead of c.name.
Turning your Onsen UI + Vue project into a Cordova app is simple using the vue-cli-plugin-cordova plugin. Simply follow the instructions there to get going.
The main guide describes how to disable or set some global features “right after including onsenui.js in the app”. This means that it must take effect before any component is rendered. Since the ons object is not provided globally, we need to use the $ons object at the very first possible location:
import Vue from 'vue';
import VueOnsen from 'vue-onsenui';
Vue.use(VueOnsen);
new Vue({
el: '#app',
render: h => h(...),
beforeCreate() {
this.$ons.disableAutoStyling(); // Or any other method
}
})
This way, changes take effect before any component is rendered.
A Navigator’s pages are sibling elements, which means that communication among them in Vue is fairly challenging. Vuex is a good solution for this, but not the only one. When you push a new page component and want to add some initial data, you can simply extend it:
import nextPage from 'nextPage.vue';
// ...
pageStack.push({
extends: nextPage,
data() {
return {
myCustomDataHere: 42
};
}
})
In order to send data back to the previous page before popping, take a look at Vue state management.
Absolutely. Vuex is a good solution for component communication. If you feel you have too many props and events, Vuex may be a good fit. For an example of Onsen UI + Vue + Vuex, see the kitchensink app.
Onsen UI provides its own routing components: v-ons-navigator, v-ons-tabbar and v-ons-splitter. These components can be mixed in many ways to achieve the desired route pattern. This is generally enough for mobile single-page application, so there is no need to plug an external router.
However, for those who really want to integrate vue-router, it is fully compatible with Onsen UI. It simply has to be integrated with the three routing components mentioned above.
Splitter:
For v-ons-splitter, simply put your router-view in the place where v-ons-page components are normally located. In other words, inside v-ons-splitter-content or v-ons-splitter-side.
<v-ons-splitter>
<v-ons-splitter-side>...</v-ons-splitter-side>
<v-ons-splitter-content>
<router-view></router-view>
</v-ons-splitter-content>
</v-ons-splitter>
Tabbar:
v-ons-tabbar accepts a slots syntax that allows us to include router-view in the pages slot. Also, v-ons-tab default behavior must be overriden in the click handler in order to let the router do the job.
<v-ons-tabbar>
<router-view slot="pages"></router-view>
<v-ons-tab v-for="name in ['Home', 'Settings']" :key="name"
:label="name"
:active="$route.name === name"
@click.prevent="$router.push({name})"
></v-ons-tab>
</v-ons-tabbar>
Navigator: In this case we don’t need <router-view> at all. The router simply has to decide what’s going to be the next page stack for the navigator, and the latter will do all the job (transitions, events, etc.):
template: `
<div id="app">
<v-ons-navigator swipeable
:page-stack="pageStack"
:pop-page="goBack"
></v-ons-navigator>
</div>
`,
methods: {
goBack() {
this.$router.push({ name: this.$route.matched[this.$route.matched.length - 2].name });
}
},
created() {
const mapRouteStack = route => this.pageStack = route.matched.map(m => m.components.default);
mapRouteStack(this.$route);
this.$router.beforeEach((to, from, next) => mapRouteStack(to) && next());
}
Notice that the previous example is adding every route to the Navigator’s page stack. It assumes all the routes have a valid page (v-ons-page) as their default component. If this is not your case, simply filter out the routes you don’t need.
Once the router gives the new page stack to the Navigator, this one compares the current stack with the previous one. If the number of pages/routes has decreased and the top page has changed, it will perform a ‘popPage’ transition. Otherwise it will be ‘pushPage’.
Due to this, going back in the browser history ($router.go(-1)) to a deeper route will push a page rather than popping. Therefore, going back in the history with the v-ons-back-button is not recommended unless you have extra logic in your router to avoid unwanted behaviors.
In this example, the v-ons-back-button components runs goBack method, which is simply pushing the parent route (asumming it is the previous v-ons-page) instead of going back in the history. This behavior will likely fit most mobile apps.
For a more complete example of v-ons-navigator with vue-router, have a look at this repository.